Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/Group.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/Group.cs	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/Group.cs	(revision 13045)
@@ -21,6 +21,6 @@
 
 using System;
+using System.Collections;
 using System.Collections.Generic;
-using System.Collections.ObjectModel;
 using System.Drawing;
 using System.Linq;
@@ -29,27 +29,26 @@
 namespace HeuristicLab.Visualization {
   public class Group : PrimitiveBase, IGroup {
-    private LinkedList<IPrimitive> myPrimitives;
-    private HashSet<IPrimitive> myPrimitivesLookup;
-    public virtual ReadOnlyCollection<IPrimitive> Primitives {
-      get { return new ReadOnlyCollection<IPrimitive>(new List<IPrimitive>(myPrimitives)); }
-    }
-    public virtual ReadOnlyCollection<IPrimitive> SelectedPrimitives {
-      get {
-        List<IPrimitive> selected = new List<IPrimitive>();
-        foreach (IPrimitive primitive in myPrimitives) {
-          if (primitive.Selected) selected.Add(primitive);
-        }
-        return new ReadOnlyCollection<IPrimitive>(selected);
-      }
-    }
+    private readonly LinkedList<IPrimitive> primitives;
+    private readonly HashSet<IPrimitive> primitivesLookup;
+
+    public virtual IEnumerable<IPrimitive> Primitives {
+      get { return primitives.ToArray(); }
+    }
+    public virtual IEnumerable<IPrimitive> SelectedPrimitives {
+      get { return primitives.Where(x => x.Selected).ToArray(); }
+    }
+
     public override bool Selected {
       get { return base.Selected; }
       set {
-        bool updateEnabled = UpdateEnabled;
-        UpdateEnabled = false;
-        foreach (IPrimitive primitive in myPrimitives)
-          primitive.Selected = value;
-        UpdateEnabled = updateEnabled;
-        base.Selected = value;
+        SuppressEvents = true;
+        try {
+          foreach (var primitive in primitives)
+            primitive.Selected = value;
+          base.Selected = value;
+        } finally {
+          SuppressEvents = false;
+          OnRedrawRequired();
+        }
       }
     }
@@ -57,81 +56,104 @@
     public Group(IChart chart)
       : base(chart) {
-      myPrimitives = new LinkedList<IPrimitive>();
-      myPrimitivesLookup = new HashSet<IPrimitive>();
+      primitives = new LinkedList<IPrimitive>();
+      primitivesLookup = new HashSet<IPrimitive>();
     }
 
     public virtual void Add(IPrimitive primitive) {
-      if (Contains(primitive))
-        throw new ArgumentException("Primitive already added");
-
-      myPrimitives.AddFirst(primitive);
-      myPrimitivesLookup.Add(primitive);
-      primitive.Group = this;
-      primitive.Update += new EventHandler(primitive_Update);
-      OnUpdate();
+      if (Contains(primitive)) throw new ArgumentException("Primitive already added");
+      primitives.AddFirst(primitive);
+      primitivesLookup.Add(primitive);
+      primitive.RedrawRequired += PrimitiveOnRedrawRequired;
+      OnRedrawRequired();
     }
     public virtual void AddRange(IEnumerable<IPrimitive> primitives) {
-      foreach (IPrimitive primitive in primitives) {
-        if (Contains(primitive))
-          throw new ArgumentException("Primitive already added");
-
-        myPrimitives.AddFirst(primitive);
-        myPrimitivesLookup.Add(primitive);
-        primitive.Group = this;
-        primitive.Update += new EventHandler(primitive_Update);
-      }
-      OnUpdate();
-    }
+      foreach (var primitive in this.primitives) {
+        if (Contains(primitive)) throw new ArgumentException("Primitive already added");
+        this.primitives.AddFirst(primitive);
+        primitivesLookup.Add(primitive);
+        primitive.RedrawRequired += PrimitiveOnRedrawRequired;
+      }
+      OnRedrawRequired();
+    }
+
     public virtual bool Contains(IPrimitive primitive) {
-      return myPrimitivesLookup.Contains(primitive);
-    }
+      return primitivesLookup.Contains(primitive);
+    }
+
     public virtual bool Remove(IPrimitive primitive) {
-      if (myPrimitives.Remove(primitive)) {
-        primitive.Group = null;
-        primitive.Update -= new EventHandler(primitive_Update);
-        OnUpdate();
-        return true;
-      } else {
-        return false;
-      }
-    }
+      if (!primitives.Remove(primitive)) return false;
+      primitivesLookup.Remove(primitive);
+
+      primitive.RedrawRequired -= PrimitiveOnRedrawRequired;
+      OnRedrawRequired();
+      return true;
+    }
+
     public virtual void Clear() {
-      foreach (IPrimitive primitive in myPrimitives) {
-        primitive.Group = null;
-        primitive.Update -= new EventHandler(primitive_Update);
-      }
-      myPrimitives.Clear();
-      myPrimitivesLookup.Clear();
-      OnUpdate();
+      foreach (var primitive in primitives) {
+        primitive.RedrawRequired -= PrimitiveOnRedrawRequired;
+      }
+      primitives.Clear();
+      primitivesLookup.Clear();
+      OnRedrawRequired();
     }
 
     public virtual IPrimitive GetPrimitive(PointD point) {
-      return myPrimitives.FirstOrDefault(primitive => primitive.ContainsPoint(point));
-    }
-
-    public IPrimitive GetPrimitive(double x, double y) {
-      return GetPrimitive(new PointD(x, y));
-    }
-    public virtual IList<IPrimitive> GetAllPrimitives(PointD point) {
-      var primitives = new List<IPrimitive>();
-      foreach (var primitive in myPrimitives.Where(primitive => primitive.ContainsPoint(point))) {
-        primitives.Add(primitive);
+      return primitives.FirstOrDefault(primitive => primitive.ContainsPoint(point));
+    }
+
+    public virtual IEnumerable<IPrimitive> GetAllPrimitives(PointD point) {
+      var result = new List<IPrimitive>();
+      foreach (var primitive in primitives.Where(primitive => primitive.ContainsPoint(point))) {
+        result.Add(primitive);
         var group = primitive as IGroup;
         if (group != null)
-          primitives.AddRange(group.Primitives);
-      }
-      return primitives;
-    }
-    public IList<IPrimitive> GetAllPrimitives(double x, double y) {
-      return GetAllPrimitives(new PointD(x, y));
+          result.AddRange(group.GetAllPrimitives(point));
+      }
+      return result;
     }
 
     public override void Move(Offset delta) {
-      bool updateEnabled = UpdateEnabled;
-      UpdateEnabled = false;
-      foreach (IPrimitive primitive in myPrimitives)
-        primitive.Move(delta);
-      UpdateEnabled = updateEnabled;
-      OnUpdate();
+      SuppressEvents = true;
+      try {
+        foreach (var primitive in primitives)
+          primitive.Move(delta);
+      } finally {
+        SuppressEvents = false;
+        OnRedrawRequired();
+      }
+    }
+
+    public override void Move(PointD point, Offset delta) {
+      SuppressEvents = true;
+      try {
+        foreach (var primitive in primitives)
+          primitive.Move(point, delta);
+      } finally {
+        SuppressEvents = false;
+        OnRedrawRequired();
+      }
+    }
+
+    public override void SnapToGrid(IGrid grid) {
+      SuppressEvents = true;
+      try {
+        foreach (var primitive in primitives)
+          primitive.SnapToGrid(grid);
+      } finally {
+        SuppressEvents = false;
+        OnRedrawRequired();
+      }
+    }
+
+    public override void SnapToGrid(PointD point, IGrid grid) {
+      SuppressEvents = true;
+      try {
+        foreach (var primitive in primitives)
+          primitive.SnapToGrid(point, grid);
+      } finally {
+        SuppressEvents = false;
+        OnRedrawRequired();
+      }
     }
 
@@ -141,19 +163,17 @@
 
     public override Cursor GetCursor(PointD point) {
-      IPrimitive primitive = GetPrimitive(point);
-      if (primitive != null) return primitive.GetCursor(point);
-      else return base.GetCursor(point);
-    }
+      var primitive = GetPrimitive(point);
+      return primitive != null ? primitive.GetCursor(point) : base.GetCursor(point);
+    }
+
     public override string GetToolTipText(PointD point) {
-      IPrimitive primitive = GetPrimitive(point);
-      if (primitive != null) return primitive.GetToolTipText(point);
-      else return base.GetToolTipText(point);
+      var primitive = GetPrimitive(point);
+      return primitive != null ? primitive.GetToolTipText(point) : base.GetToolTipText(point);
     }
 
     public void OneLayerUp(IPrimitive primitive) {
-      if (!Contains(primitive))
-        throw new ArgumentException("Primitive not found");
-
-      var curr = myPrimitives.Find(primitive);
+      if (!Contains(primitive)) throw new ArgumentException("Primitive not found");
+
+      var curr = primitives.Find(primitive);
       if (curr == null) return;
       var prev = curr.Previous;
@@ -162,12 +182,10 @@
       prev.Value = temp;
 
-      OnUpdate();
-    }
-
+      OnRedrawRequired();
+    }
     public void OneLayerDown(IPrimitive primitive) {
-      if (!Contains(primitive))
-        throw new ArgumentException("Primitive not found");
-
-      var curr = myPrimitives.Find(primitive);
+      if (!Contains(primitive)) throw new ArgumentException("Primitive not found");
+
+      var curr = primitives.Find(primitive);
       if (curr == null) return;
       var next = curr.Next;
@@ -177,22 +195,19 @@
     }
     public void IntoForeground(IPrimitive primitive) {
-      if (!Contains(primitive))
-        throw new ArgumentException("Primitive not found");
-
-      myPrimitives.Remove(primitive);
-      myPrimitives.AddFirst(primitive);
-      OnUpdate();
+      if (!Contains(primitive)) throw new ArgumentException("Primitive not found");
+      primitives.Remove(primitive);
+      primitives.AddFirst(primitive);
+      OnRedrawRequired();
     }
     public void IntoBackground(IPrimitive primitive) {
-      if (!Contains(primitive))
-        throw new ArgumentException("Primitive not found");
-
-      myPrimitives.Remove(primitive);
-      myPrimitives.AddLast(primitive);
-      OnUpdate();
+      if (!Contains(primitive)) throw new ArgumentException("Primitive not found");
+
+      primitives.Remove(primitive);
+      primitives.AddLast(primitive);
+      OnRedrawRequired();
     }
 
     public override void Draw(Graphics graphics) {
-      var current = myPrimitives.Last;
+      var current = primitives.Last;
       while (current != null) {
         var primitive = current.Value;
@@ -204,6 +219,15 @@
     }
 
-    private void primitive_Update(object sender, EventArgs e) {
-      OnUpdate();
+    private void PrimitiveOnRedrawRequired(object sender, EventArgs e) {
+      if (SuppressEvents) return;
+      OnRedrawRequired();
+    }
+
+    public IEnumerator<IPrimitive> GetEnumerator() {
+      return primitives.GetEnumerator();
+    }
+
+    IEnumerator IEnumerable.GetEnumerator() {
+      return GetEnumerator();
     }
   }
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/Line.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/Line.cs	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/Line.cs	(revision 13045)
@@ -28,12 +28,6 @@
       : base(chart, start, end) {
     }
-    public Line(IChart chart, double x1, double y1, double x2, double y2)
-      : this(chart, new PointD(x1, y1), new PointD(x2, y2)) {
-    }
     public Line(IChart chart, PointD start, PointD end, Pen pen)
       : base(chart, start, end, pen, null) {
-    }
-    public Line(IChart chart, double x1, double y1, double x2, double y2, Pen pen)
-      : this(chart, new PointD(x1, y1), new PointD(x2, y2), pen) {
     }
 
@@ -41,6 +35,6 @@
       if (base.ContainsPoint(point)) return true;
 
-      double penWidthX = Chart.PixelToWorldRatio.Width * (Pen.Width + 1);
-      double penWidthY = Chart.PixelToWorldRatio.Height * (Pen.Width + 1);
+      double penWidthX = Chart.PixelToWorldRatio.Width * (Pen.Width + 3);
+      double penWidthY = Chart.PixelToWorldRatio.Height * (Pen.Width + 3);
 
       if ((point.X < (Math.Min(Start.X, End.X) - (penWidthX / 2))) ||
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/LinearPrimitiveBase.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/LinearPrimitiveBase.cs	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/LinearPrimitiveBase.cs	(revision 13045)
@@ -20,4 +20,5 @@
 #endregion
 
+using System;
 using System.Drawing;
 using System.Drawing.Drawing2D;
@@ -26,5 +27,5 @@
 namespace HeuristicLab.Visualization {
   public abstract class LinearPrimitiveBase : PrimitiveBase {
-    protected IGroup selectionRectangles;
+    protected IGroup SelectionRectangles;
 
     private PointD myStart;
@@ -45,19 +46,13 @@
     protected LinearPrimitiveBase(IChart chart, PointD start, PointD end)
       : base(chart) {
-      selectionRectangles = new Group(chart);
+      SelectionRectangles = new Group(chart);
       myStart = start;
       myEnd = end;
     }
-    protected LinearPrimitiveBase(IChart chart, double x1, double y1, double x2, double y2)
-      : this(chart, new PointD(x1, y1), new PointD(x2, y2)) {
-    }
     protected LinearPrimitiveBase(IChart chart, PointD start, PointD end, Pen pen, Brush brush)
       : base(chart, pen, brush) {
-      selectionRectangles = new Group(chart);
+      SelectionRectangles = new Group(chart);
       myStart = start;
       myEnd = end;
-    }
-    protected LinearPrimitiveBase(IChart chart, double x1, double y1, double x2, double y2, Pen pen, Brush brush)
-      : this(chart, new PointD(x1, y1), new PointD(x2, y2), pen, brush) {
     }
 
@@ -65,40 +60,65 @@
       myStart = start;
       myEnd = end;
-      OnUpdate();
+      OnRedrawRequired();
     }
-    public void SetPosition(double x1, double y1, double x2, double y2) {
-      SetPosition(new PointD(x1, y1), new PointD(x2, y2));
-    }
+
     public override void Move(Offset delta) {
       SetPosition(Start + delta, End + delta);
     }
 
-    public override bool ContainsPoint(PointD point) {
-      if (Selected) {
-        if (selectionRectangles.GetPrimitive(point) != null) return true;
-      }
-      return false;
+    public override void Move(PointD point, Offset delta) {
+      if (Selected && SelectionRectangles.ContainsPoint(point)) {
+        var rect = (SelectionRectangle)SelectionRectangles.GetPrimitive(point);
+        if (rect.Point == Start) {
+          SetPosition(Start + delta, End);
+        } else if (rect.Point == End) {
+          SetPosition(Start, End + delta);
+        }
+      } else SetPosition(Start + delta, End + delta);
     }
 
-    public override void MouseDrag(PointD point, Offset offset, MouseButtons button) {
-      if (button == MouseButtons.Left) {
-        if (Selected) {
-          if (selectionRectangles.ContainsPoint(point)) {
-            SelectionRectangle rect = (SelectionRectangle)selectionRectangles.GetPrimitive(point);
-            if (rect.Point == Start) {
-              SetPosition(Start + offset, End);
-            } else if (rect.Point == End) {
-              SetPosition(Start, End + offset);
-            }
-          } else {
-            base.MouseDrag(point, offset, button);
-          }
+    public override void SnapToGrid(IGrid grid) {
+      var bl = grid.GetBottomLeftGridPoint(Start);
+      var ur = grid.GetUpperRightGridPoint(Start);
+      var sx = Math.Abs(bl.X - Start.X) <= Math.Abs(ur.X - Start.X) ? bl.X : ur.X;
+      var sy = Math.Abs(bl.Y - Start.Y) <= Math.Abs(ur.Y - Start.Y) ? bl.Y : ur.Y;
+
+      var end = new PointD(End.X + (sx - Start.X), End.Y + (sy - Start.Y));
+
+      bl = grid.GetBottomLeftGridPoint(end);
+      ur = grid.GetUpperRightGridPoint(end);
+      var ex = Math.Abs(bl.X - end.X) <= Math.Abs(ur.X - end.X) ? bl.X : ur.X;
+      var ey = Math.Abs(bl.Y - end.Y) <= Math.Abs(ur.Y - end.Y) ? bl.Y : ur.Y;
+
+      SetPosition(new PointD(sx, sy), new PointD(ex, ey));
+    }
+
+    public override void SnapToGrid(PointD point, IGrid grid) {
+      if (Selected && SelectionRectangles.ContainsPoint(point)) {
+        var rect = (SelectionRectangle)SelectionRectangles.GetPrimitive(point);
+        if (rect.Point == Start) {
+          var bl = grid.GetBottomLeftGridPoint(Start);
+          var ur = grid.GetUpperRightGridPoint(Start);
+          var sx = Math.Abs(bl.X - Start.X) <= Math.Abs(ur.X - Start.X) ? bl.X : ur.X;
+          var sy = Math.Abs(bl.Y - Start.Y) <= Math.Abs(ur.Y - Start.Y) ? bl.Y : ur.Y;
+          SetPosition(new PointD(sx, sy), End);
+        } else if (rect.Point == End) {
+          var bl = grid.GetBottomLeftGridPoint(End);
+          var ur = grid.GetUpperRightGridPoint(End);
+          var ex = Math.Abs(bl.X - End.X) <= Math.Abs(ur.X - End.X) ? bl.X : ur.X;
+          var ey = Math.Abs(bl.Y - End.Y) <= Math.Abs(ur.Y - End.Y) ? bl.Y : ur.Y;
+          SetPosition(Start, new PointD(ex, ey));
         }
-      }
+      } else SnapToGrid(grid);
+    }
+
+    public override bool ContainsPoint(PointD point) {
+      if (Selected && SelectionRectangles.GetPrimitive(point) != null) return true;
+      return false;
     }
 
     public override Cursor GetCursor(PointD point) {
       if (Selected) {
-        Cursor cursor = selectionRectangles.GetCursor(point);
+        var cursor = SelectionRectangles.GetCursor(point);
         if (cursor != null) return cursor;
       }
@@ -107,15 +127,14 @@
 
     public override void PostDraw(Graphics graphics) {
-      selectionRectangles.Clear();
+      SelectionRectangles.Clear();
       if (Selected) {
-        Pen pen = new Pen(Color.LightGray, 3);
-        pen.DashStyle = DashStyle.Dash;
+        var pen = new Pen(Color.LightGray, 3) { DashStyle = DashStyle.Dash };
         graphics.DrawLine(pen,
                           Chart.TransformWorldToPixel(Start),
                           Chart.TransformWorldToPixel(End));
-        selectionRectangles.Add(new SelectionRectangle(Chart, Start, Cursors.SizeAll));
-        selectionRectangles.Add(new SelectionRectangle(Chart, End, Cursors.SizeAll));
+        SelectionRectangles.Add(new SelectionRectangle(Chart, Start, Cursors.SizeAll));
+        SelectionRectangles.Add(new SelectionRectangle(Chart, End, Cursors.SizeAll));
 
-        selectionRectangles.Draw(graphics);
+        SelectionRectangles.Draw(graphics);
       }
     }
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/PrimitiveBase.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/PrimitiveBase.cs	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/PrimitiveBase.cs	(revision 13045)
@@ -26,154 +26,78 @@
 namespace HeuristicLab.Visualization {
   public abstract class PrimitiveBase : IPrimitive {
-    private IChart myChart;
+    private readonly IChart chart;
     public IChart Chart {
-      get { return myChart; }
-    }
-    private IGroup myGroup;
-    public IGroup Group {
-      get { return myGroup; }
-      set { myGroup = value; }
+      get { return chart; }
     }
 
-    private Pen myPen;
+    private Pen pen;
     public virtual Pen Pen {
-      get { return myPen; }
+      get { return pen; }
       set {
-        myPen = value;
-        OnUpdate();
+        pen = value;
+        OnRedrawRequired();
       }
     }
-    private Brush myBrush;
+    private Brush brush;
     public virtual Brush Brush {
-      get { return myBrush; }
+      get { return brush; }
       set {
-        myBrush = value;
-        OnUpdate();
+        brush = value;
+        OnRedrawRequired();
       }
     }
 
-    private bool myUpdateEnabled;
-    public bool UpdateEnabled {
-      get { return myUpdateEnabled; }
-      set { myUpdateEnabled = value; }
-    }
+    public string ToolTipText { get; set; }
 
-    private bool mySelected;
+    public object Tag { get; set; }
+
+    protected bool SuppressEvents { get; set; }
+
+    private bool selected;
     public virtual bool Selected {
-      get { return mySelected; }
+      get { return selected; }
       set {
-        mySelected = value;
-        OnUpdate();
+        if (selected == value) return;
+        selected = value;
+        OnRedrawRequired();
       }
     }
 
-    private string myToolTipText;
-    public string ToolTipText {
-      get { return myToolTipText; }
-      set { myToolTipText = value; }
+    protected PrimitiveBase(IChart chart)
+      : this(chart, Pens.Black, Brushes.White) {
     }
-
-    private object myTag;
-    public object Tag {
-      get { return myTag; }
-      set { myTag = value; }
-    }
-
-    protected PrimitiveBase(IChart chart) {
-      myChart = chart;
-      myGroup = null;
-      myPen = Pens.Black;
-      myBrush = Brushes.White;
-      myUpdateEnabled = true;
-      mySelected = false;
-      myToolTipText = null;
-      myTag = null;
-    }
-    protected PrimitiveBase(IChart chart, Pen pen, Brush brush)
-      : this(chart) {
-      myPen = pen;
-      myBrush = brush;
+    protected PrimitiveBase(IChart chart, Pen pen, Brush brush) {
+      this.chart = chart;
+      this.pen = pen;
+      this.brush = brush;
+      selected = false;
+      ToolTipText = null;
+      Tag = null;
     }
 
     public abstract void Move(Offset delta);
-    public void Move(double dx, double dy) {
-      Move(new Offset(dx, dy));
-    }
+    public abstract void Move(PointD point, Offset delta);
+
+    public abstract void SnapToGrid(IGrid grid);
+    public abstract void SnapToGrid(PointD point, IGrid grid);
 
     public abstract bool ContainsPoint(PointD point);
-    public bool ContainsPoint(double x, double y) {
-      return ContainsPoint(new PointD(x, y));
-    }
 
     public virtual Cursor GetCursor(PointD point) {
       return null;
     }
-    public Cursor GetCursor(double x, double y) {
-      return GetCursor(new PointD(x, y));
-    }
+
     public virtual string GetToolTipText(PointD point) {
       return ToolTipText;
     }
-    public string GetToolTipText(double x, double y) {
-      return GetToolTipText(new PointD(x, y));
-    }
 
-    public void OneLayerUp() {
-      Group.OneLayerUp(this);
-    }
-    public void OneLayerDown() {
-      Group.OneLayerDown(this);
-    }
-    public void IntoForeground() {
-      Group.IntoForeground(this);
-    }
-    public void IntoBackground() {
-      Group.IntoBackground(this);
-    }
+    public virtual void PreDraw(Graphics graphics) { }
+    public virtual void Draw(Graphics graphics) { }
+    public virtual void PostDraw(Graphics graphics) { }
 
-    public virtual void MouseClick(PointD point, MouseButtons button) {
-      if (button == MouseButtons.Left) {
-        Selected = true;
-      }
-    }
-    public void MouseClick(double x, double y, MouseButtons button) {
-      MouseClick(new PointD(x, y), button);
-    }
-    public virtual void MouseDoubleClick(PointD point, MouseButtons button) {
-    }
-    public void MouseDoubleClick(double x, double y, MouseButtons button) {
-      MouseDoubleClick(new PointD(x, y), button);
-    }
-    public virtual void MouseMove(PointD point, Offset offset) {
-    }
-    public void MouseMove(double x, double y, double dx, double dy) {
-      MouseMove(new PointD(x, y), new Offset(dx, dy));
-    }
-    public virtual void MouseDrag(PointD point, Offset offset, MouseButtons button) {
-      if (button == MouseButtons.Left) {
-        Move(offset);
-      }
-    }
-    public void MouseDrag(double x, double y, double dx, double dy, MouseButtons button) {
-      MouseDrag(new PointD(x, y), new Offset(dx, dy), button);
-    }
-
-    public virtual void PreDraw(Graphics graphics) {
-    }
-    public virtual void Draw(Graphics graphics) {
-    }
-    public virtual void PostDraw(Graphics graphics) {
-    }
-
-    public event EventHandler Update;
-    public void EnforceUpdate() {
-      if (Update != null) {
-        Update(this, new EventArgs());
-      }
-    }
-    protected virtual void OnUpdate() {
-      if ((UpdateEnabled) && (Update != null)) {
-        Update(this, new EventArgs());
-      }
+    public event EventHandler RedrawRequired;
+    protected virtual void OnRedrawRequired() {
+      var handler = RedrawRequired;
+      if (!SuppressEvents && handler != null) handler(this, EventArgs.Empty);
     }
   }
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/Rectangle.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/Rectangle.cs	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/Rectangle.cs	(revision 13045)
@@ -27,12 +27,6 @@
       : base(chart, lowerLeft, upperRight) {
     }
-    public Rectangle(IChart chart, double x1, double y1, double x2, double y2)
-      : this(chart, new PointD(x1, y1), new PointD(x2, y2)) {
-    }
     public Rectangle(IChart chart, PointD lowerLeft, PointD upperRight, Pen pen, Brush brush)
       : base(chart, lowerLeft, upperRight, pen, brush) {
-    }
-    public Rectangle(IChart chart, double x1, double y1, double x2, double y2, Pen pen, Brush brush)
-      : this(chart, new PointD(x1, y1), new PointD(x2, y2), pen, brush) {
     }
 
